#ifndef LDAP_PLUGIN_H
#define LDAP_PLUGIN_H

#include <string.h>
//#include <multisync.h>
#include "../../../src/syncengine.h"
#include <ldap.h>
#include <libxml/xmlmemory.h>
#include <libxml/parser.h>

typedef struct {
	client_connection commondata;
	sync_pair *handle;
	connection_type type;
	int debug_level;
	int scope;
	char statefile[1024];
	char dbfile[1024];
	char *servername;
	int serverport;
	char *binddn;
	char *pwd;
	char *searchbase;
	char *filter;
	LDAP *ld;
} ldap_connection;

struct data_entry {
	char *entryUUID;
	char *modifyTimestamp;
	char *uid;
	int change_type;
	LDAPMod **ldapdata;
};

extern gboolean multisync_debug;
GList *load_ldap_entries(ldap_connection *);
GList *load_xml_entries(ldap_connection *);
LDAPMod **vcard2ldap(ldap_connection*, char *);
struct data_entry *ldap_get_entry(ldap_connection *, char *);
char *quoted_encode(char *);
char *quoted_decode(char *);

#endif
